From e61db0e4f9d0d2f2cb8d41bae58abb0f1c628712 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 16:38:03 +0000
Subject: [PATCH 834/2232] Fix symlink removal on windows


---

diff --git a/gen/build/src/out.rs b/gen/build/src/out.rs
index 76e27f6..b97e992 100644
--- a/gen/build/src/out.rs
+++ b/gen/build/src/out.rs
@@ -54,7 +54,7 @@ pub(crate) fn symlink_dir(src: impl AsRef<Path>, dst: impl AsRef<Path>) -> Resul
 
     let mut create_dir_error = None;
     if dst.exists() {
-        let _ = fs::remove_file(dst).unwrap();
+        let _ = paths::remove_symlink_dir(dst).unwrap();
     } else {
         let parent = dst.parent().unwrap();
         create_dir_error = fs::create_dir_all(parent).err();
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index d4b2ebb..1007730 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -120,3 +120,11 @@ pub(crate) use self::fs::symlink_dir;
 pub(crate) fn symlink_dir(_src: impl AsRef<Path>, _dst: impl AsRef<Path>) -> fs::Result<()> {
     Ok(())
 }
+
+#[cfg(not(windows))]
+pub(crate) use self::fs::remove_file as remove_symlink_dir;
+
+// On Windows, trying to use remove_file to remove a symlink which points to a
+// directory fails with "Access is denied".
+#[cfg(windows)]
+pub(crate) use self::fs::remove_dir as remove_symlink_dir;
diff --git a/gen/src/fs.rs b/gen/src/fs.rs
index f135a8a..89965ee 100644
--- a/gen/src/fs.rs
+++ b/gen/src/fs.rs
@@ -74,6 +74,14 @@ pub(crate) fn remove_file(path: impl AsRef<Path>) -> Result<()> {
     }
 }
 
+pub(crate) fn remove_dir(path: impl AsRef<Path>) -> Result<()> {
+    let path = path.as_ref();
+    match std::fs::remove_dir(path) {
+        Ok(()) => Ok(()),
+        Err(e) => err!(e, "Failed to remove directory `{}`", path),
+    }
+}
+
 fn symlink<'a>(
     src: &'a Path,
     dst: &'a Path,

